<p align="center">
 <img src="https://rawgit.com/Niklan/Glisseo/8.x-1.x/logo.svg" align="center" alt="Glisseo Logo">

 <p align="center">
   Base theme for Drupal with starterkit.
 </p>
</p>

## Quick start

1. Download and place the glisseo folder to /themes
2. Copy STARTER theme and place it in /themes as well.
3. Rename STARTER folder to your future theme name, f.e. 'mytheme'.
4. Replace every uppercase filenames in the root of your theme with it's name. Also, don't forget to replace it inside yaml files when it needed.

## What's this

*  SCSS preprocessor for better CSS experience.
*  Configured [stylelint](https://stylelint.io/) for control coding standards across the project.
*  [Lost Grid](http://lostgrid.org) for creating website much faster with flexible grids.
*  [Material Design Icons](https://materialdesignicons.com/) for using SVG icons.
*  Breakpoint for making your site responsive.
*  [SMACSS alike architecture, improved to Drupal experience.](docs/scss-architecture.md)
*  Good structure.
*  Clear Views templates with more semantic code (footer, section, header).
*  Lots of other mixins and functions that will make your theming easier and enjoyable.
*  and much more..

Due of the theme structure, where all parts are separated of each other, you can disable most of them without any pain and consequences, just remove import line and delete files. Theme is highly customazible and you can easily replace any part of it by your needs.


## Documentation

*  [Getting started](docs/getting-started.md)
*  [SCSS architecture](docs/scss-architecture.md)
*  [Responsive guide](docs/responsive-guide.md)
*  [BrowserSync and LiveReload integration](docs/live-reload.md)
*  [Tips, tricks and snippets](docs/tips-tricks-snippets.md)
*  [FontAwesome icon integration](docs/font-awesome.md)